﻿Option Strict On
Imports Microsoft.Phone.Tasks
Imports ExifLib
Imports Microsoft.Phone 'PictureDecorderのために必要
Imports System.IO 'SeekOriginのために必要
Imports Microsoft.Xna.Framework.Media
Imports System.Windows.Media.Imaging

Partial Public Class MainPage
    Inherits PhoneApplicationPage

    ' コンストラクター
    Public Sub New()
        InitializeComponent()
    End Sub
    Dim myCameraCaptureTask As CameraCaptureTask
    Dim myOrientation As ExifLib.ExifOrientation
    Dim imageBytes As Byte()
    Dim myCaptureImage As Stream
    Protected Overrides Sub OnNavigatedTo(e As System.Windows.Navigation.NavigationEventArgs)
        myCameraCaptureTask = New CameraCaptureTask
        AddHandler myCameraCaptureTask.Completed, Sub(resultSender As Object, resultArgs As PhotoResult)
                                                      If resultArgs.TaskResult = TaskResult.OK Then
                                                          myCaptureImage = resultArgs.ChosenPhoto
                                                          resultArgs.ChosenPhoto.Position = 0
                                                          Dim info As JpegInfo = ExifReader.ReadJpeg(resultArgs.ChosenPhoto, resultArgs.OriginalFileName)
                                                          myOrientation = info.Orientation

                                                          Dim myAngle As Integer = 0

                                                          Select Case info.Orientation
                                                              Case ExifOrientation.TopLeft 'カメラ横向き
                                                                  myAngle = 0
                                                                  Exit Select
                                                              Case ExifOrientation.TopRight 'カメラ縦向き
                                                                  myAngle = 90
                                                                  Exit Select
                                                          End Select
                                                          myComposite.Rotation = myAngle

                                                          imageBytes = New Byte(CInt(resultArgs.ChosenPhoto.Length)) {}


                                                          resultArgs.ChosenPhoto.Read(imageBytes, 0, imageBytes.Length)
                                                          resultArgs.ChosenPhoto.Seek(0, SeekOrigin.Begin)
                                                          Dim imageSource As WriteableBitmap = PictureDecoder.DecodeJpeg(resultArgs.ChosenPhoto)

                                                          Image2.Source = imageSource
                                                      Else
                                                          saveButton.IsEnabled = False
                                                          Exit Sub
                                                      End If

                                                  End Sub
        MyBase.OnNavigatedTo(e)
    End Sub

    Private Sub cameraButton_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles cameraButton.Click
        MessageBox.Show("カメラの解像度を低く設定し、設定の保存を行って、写真を撮ってください。")
        myCameraCaptureTask.Show()
        saveButton.IsEnabled = True
    End Sub

    Private Sub saveButton_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles saveButton.Click
        Dim imageFileName As String = DateTime.Now.ToString("yyyyMMddHHmmss") & ".jpg"
        myCaptureImage.Seek(0, 0)
        Dim myLibray As New MediaLibrary
        myLibray.SavePicture(imageFileName, myCaptureImage)
        MessageBox.Show("PicturesHubに保存しました。")
    End Sub
End Class
